{ // configurações para o AppFramewok
	$.ui.useOSThemes = false;
	$.feat.nativeTouchScroll = true;
	$.ui.animateHeaders = false;
	$.ui.disableSideMenu();
	$.ui.autoLaunch = false;
}

document.addEventListener("deviceready", function () {
	$(document).on("afui:ready", Radar.iniciar);
	$.ui.launch();
}, false);

function localizar(terminarIniciar) {

	var languageControls = function (language) {
		var lang = '';

		if (language.toString().indexOf("es") != -1) {
			lang = 'es';

		} else if (language.toString().indexOf("en") != -1) {
			lang = 'en';

		} else {
			lang = 'pt';
		}

		onNetworkCall(lang, function (obj) {
			$("[data-text]").each(function () {
				$(this).text(obj.linguagem[0][$(this).data("text")]);
			});

			$("[data-placeholder]").each(function () {
				$(this).attr("placeholder", obj.linguagem[0][$(this).data("placeholder")]);
			});

			$("[data-val]").each(function () {
				$(this).attr("value", obj.linguagem[0][$(this).data("val")]);
			});

			$(".logo-radar").each(function () {
				$(this).attr("src", 'images/' + obj.linguagem[0]['logo']);
			});

			moment.locale(Radar.lang || 'pt-br', {
				relativeTime: {
					future: langValue('time_future') || "em %s",
					past: langValue('time_past') || "%s",
					s: langValue('time_s') || "seg",
					m: langValue('time_m') || "1 min",
					mm: langValue('time_mm') || "%d min",
					h: langValue('time_h') || "1 hora",
					hh: langValue('time_hh') || "%d horas",
					d: langValue('time_d') || "1 dia",
					dd: langValue('time_dd') || "%d dias",
					M: langValue('time_M') || "1 mês",
					MM: langValue('time_MM') || "%d meses",
					y: langValue('time_y') || "1 ano",
					yy: langValue('time_yy') || "%d anos",
				}
			});

			if (obj.linguagem[0]['site'])
				Radar.app.SITE = obj.linguagem[0]['site'];

			terminarIniciar();

		});
	};

	//Network Call
	var onNetworkCall = function (lang, successCallback) {
		$.getJSON('languages/' + lang + '.json', function (data) {
			if (data.linguagem) {
				Radar.strings = data;
				successCallback(data);
			}
		});
	};

	navigator.globalization.getPreferredLanguage(function (locale) {
		Radar.lang = locale.value;
		languageControls(Radar.lang);
	});
}

function langValue(key) {
	if (!Radar.strings) {
		return key;
	}

	if (Radar.strings.linguagem[0][key]) {
		return Radar.strings.linguagem[0][key];
	}

	return key;
}


/*--------------------------------------------------------------------------------------------*/
var Radar = {};
Radar.lang = 'pt';
Radar.iniciar = function () {
	usuario.carregar();

	// localiza/traduz e depois volta a inciar
	localizar(function () {
		Radar.situacoes.dao.carregar();
		setTimeout(navigator.splashscreen.hide, 2000);
		if (!usuario.dados.pais)
			Radar.app.goToPage('pais');
	});



	//define a pagina atual (inicial) e o menu que deve iniciar selecionado
	//document.location.hash = "#info_cidade_estado";
	//Radar.app.menu_atual = $('#footer_menu1');
	$(document).on("loadpanel", Radar.app.onLoadPanels);
	usuario.tamanhoTela();


	//pedir localização ativa/exata
	if (cordova.plugins && cordova.plugins.locationAccuracy) {
		cordova.plugins.locationAccuracy.request(
			function (success) {
				console.info("Successfully requested accuracy: " + success.message);
				//carregar usuario de forma sincrona
				usuario.localizacao();
			},

			function (error) {
				console.error("Accuracy request failed: error code=" + error.code + "; error message=" + error.message);
				Radar.sair();

			},

			cordova.plugins.locationAccuracy.REQUEST_PRIORITY_HIGH_ACCURACY
		);
	} else {
		//carregar usuario de forma sincrona
		usuario.localizacao();

	}
};

Radar.sair = function () {
	if (navigator.app) {
		navigator.app.exitApp();
	} else if (navigator.device) {
		navigator.device.exitApp();
	} else {
		window.close();
	}
}

Radar.app = {
	SITE: 'https://radarcidadao.com.br',

	goToPage: function (pagina, voltando, transicao) {
		if (!transicao) transicao = 'fade';
		if (!voltando) voltando = false;
		if (!Radar.app.isOnline()) pagina = 'offline_network';
		$.ui.loadContent(pagina, false, voltando, transicao);
	},

	onLoadPanels: function () {
		// oculta ou mostra o cabeçalho (header)
		if (event.srcElement.getAttribute('data-header') == 'none') {
			document.getElementById('content').style.top = 0;
		} else {
			document.getElementById('content').style.top = ($('#header').height() - 2) + 'px';
		}

		// seleciona o menu correto no footer
		var menu = event.srcElement.getAttribute('data-menu');
		if (menu !== undefined) {
			Radar.app.menu(menu);

			// oculta a pagina de filtragem
			if (Radar.ocorrencias.filtro.visivel)
				if (!Radar.ocorrencias.filtro.alterando)
					Radar.ocorrencias.filtro.toggle();

			Radar.ocorrencias.filtro.alterando = false;
		}
	},

	menu_atual: undefined,

	menu: function (num) {
		if (this.menu_atual != undefined)
			this.menu_atual.removeClass('ativo');
		this.menu_atual = $('#footer_menu' + num);
		this.menu_atual.addClass('ativo');
	},

	carregamentoCompleto: function () {
		if (!usuario.carregado || !Radar.situacoes.dao.carregado || !usuario.dados.pais) {
			return false;
		} else {
			var btnestado = document.getElementById('btn_selecionar_estado');
			var btncidade = document.getElementById('btn_selecionar_cidade');

			if (usuario.dados.cidade && usuario.dados.estado && usuario.dados.pais) {
				btnestado.onclick = function () {
					Radar.app.goToPage('selecionar_estado');
				};
				btncidade.onclick = Radar.cidades.listaCidades;
				$(btnestado).addClass('hasChild flaticon-chevrons');
				$(btncidade).addClass('hasChild flaticon-chevrons');
				//Radar.cidades.sincronizar(false);
			} else {
				//tenta adquirir a cidade basendo-se no ip
				$('#loading-loc').addClass('ativo');

				var callback_error = function () {
					$('#btn_selecionar_estado').text(langValue('select_state'));
					$('#btn_selecionar_cidade').text(langValue('select_city'));
					$('#info_cidade_estado .message').text(langValue('loading_loc_error')).show();
					$('#loading-loc').removeClass('ativo');
					usuario.dados.estado = undefined;
					usuario.dados.cidade = undefined;
				};

				var callback_all = function () {
					$('#btn_selecionar_estado').attr('onclick', 'Radar.cidades.listaEstados()').addClass('hasChild flaticon-chevrons');
					$('#btn_selecionar_cidade').attr('onclick', 'Radar.cidades.listaCidades()').addClass('hasChild flaticon-chevrons');
					$('#loading-loc').hide();
				};

				$.getJSON("http://ip-api.com/json/", function (data) {
					var city;
					if (data.regionName && data.city && usuario.dados.pais) {
						var url = Radar.app.SITE + "?pg=estadocidade&tmpl=component" + "&estado_alias=" + data.regionName +
							"&cidade_alias=" + data.city +
							"&pais=" + usuario.dados.pais.id;
						$.getJSON(url, function (data) {
							if (data) {
								if (data.estado && data.cidade && data.estado.ativo == '1' && data.cidade.ativo == '1') {
									usuario.dados.estado = data.estado;
									usuario.dados.cidade = data.cidade;
									$('#btn_selecionar_estado').text(usuario.dados.estado.nome);
									$('#btn_selecionar_cidade').text(usuario.dados.cidade.nome).show();
									if (usuario.dados.pais && usuario.dados.estado && usuario.dados.cidade) {
										$('#btn_confirmar_cidade_estado').show();
									}
								}
							} else {
								callback_error();
							}

							callback_all();
						}).fail(function () {
							callback_error();
							callback_all();
						});

					} else {
						callback_error();
						callback_all();
					}

				}).fail(function () {
					callback_error();
					callback_all();
				});

			}
		}
	},

	openUrl: function (url) {
		//window.open(url, "_system");
		//window.open(url, '_system', 'location=yes');
		cordova.InAppBrowser.open(url, '_system', 'location=yes');
	},

	isOnline: function () {
		return navigator.connection.type !== Connection.NONE;
	},

	share: function (title, desc, link) {
		window.plugins.socialsharing.share(title, desc, null, link, function (result) {
			console.log('result: ' + result);
		}, function (result) {
			console.log('error: ' + result);
		});
	}


};


Radar.utils = {
	keyboardFix: function (scroller, element) {
		element.scrollIntoView(true);
		scroller.scrollTop = scroller.scrollTop - 50;
	},

	inputFocus: function (element, panel) {
		panel = document.getElementById(panel);
		element = document.getElementById(element);

		this.keyboardFix(panel, element);

		element.focus();
	}
};


// controller dos panels (telas)
Radar.panel = {

	cadastrar_cidade: {
		onLoad: function () {
			Radar.cidades.backTo = '';
			Radar.cidades.deleteScroll();
			Radar.cidades.scroller = new IScroll('#cadastrocidade_wrapper');
		}
	},


	selecionar_cidade: {
		onLoad: function () {
			var url = Radar.app.SITE + "?pg=listacidades&tmpl=component&estado=" + usuario.dados.estado.id;

			$.getJSON(url, function (data) {
				if (data) {
					Cookie.set('cidades', JSON.stringify(data));
					var html = '';
					for (var i = 0; i < data.length; i++) {
						if (data[i].ativo != "0") {
							html += '<li onclick="Radar.cidades.selecionarCidade(this)" data-value="' + data[i].id + '"><div class="flaticon-chevrons">' + data[i].nome + '</div></li>';
						}
					}
					$('#selecionar_cidade .lista').html(html);
				}

				$('#selecionar_cidade .carregando').removeClass('ativo');


				var li = $('#selecionar_cidade .lista li');
				li.removeClass('selecionado');

				if (usuario.dados.cidade) {
					li.each(function () {
						if (this.getAttribute('data-value') == usuario.dados.cidade.id) {
							$(this).addClass('selecionado');
							return false;
						}
					});
				}

				Radar.cidades.deleteScroll();
				Radar.cidades.scroller = new IScroll('#cidade_wrapper', {
					click: true
				});
				Radar.cidades.scroller.on('scrollEnd', function () {
					var dheight = $('#cidade_wrapper .iscroll-scroller').height() - (usuario.dados.deviceHeight || 500);
					if (this.y < -dheight) {
						$("#selecionar_cidade").addClass('fim');
						Radar.cidades.scroller.refresh()
					}
				});

				if ($('#cidade_wrapper .iscroll-scroller').height() < usuario.dados.deviceHeight) {
					$("#selecionar_cidade").addClass('fim');
					Radar.cidades.scroller.refresh()
				}

			}).fail(function () {
				console.log("Não foi possivel adquirir informações sobre cidades.");
				console.log(Radar.app.SITE + "?pg=listacidades&tmpl=component");
			});

		}
	},


	sobre: {
		onLoad: function () {
			if ($('#sobre .cidadeid').attr('data-value') != usuario.dados.cidade.id) {
				Radar.cidades.informacoesDetalhadas();
			}
		}
	},

	login: {
		onLoad: function () {
			if (usuario.dados.logado) {
				Radar.app.goToPage('cadastrar');
			} else {
				var nome = Cookie.get('nome');
				var email = Cookie.get('email');

				if (nome && email) {
					$('#login #btn_login_email').val('Mudar Cadastro').addClass('change');
					$('#login #btn_login_continuar').addClass('ativo').val('Continuar como ' + nome);
				}
			}
		}
	},

	cadastrar: {
		onLoad: function () {
			if (!usuario.dados.logado) {
				var nome = Cookie.get('nome');
				var email = Cookie.get('email');
				if (nome && email) {
					$('#login #btn_login_email').val('Mudar Cadastro').addClass('change');
					$('#login #btn_login_continuar').addClass('ativo').val('Continuar como ' + nome);
				}
				Radar.app.goToPage('login');
			} else {
				Radar.novaOcorrencia.carregarLocalizacao();
			}
		}
	},


	cadastrar_mapa: {
		onLoad: function () {
			if (Radar.novaOcorrencia.mapa.map) {
				google.maps.event.trigger(Radar.novaOcorrencia.mapa.map, 'resize');
				//Radar.novaOcorrencia.setLocalizacao(usuario.latitude, usuario.longitude);
				Radar.novaOcorrencia.mapa.map.setCenter(Radar.novaOcorrencia.mapa.markers[0].position);
			}
			if (!usuario.latitude || !usuario.longitude) {
				navigator.notification.alert(
					langValue("locnotfound"),
					false,
					langValue('loc'),
					'OK'
				);
			}
		}

	},


	mapa_ocorrencias: {
		onLoad: function () {
			var mapa = Radar.ocorrencias.mapa.get();

			if (!mapa) {
				var carregando_element = $('#mapa_ocorrencias .carregando');
				carregando_element.addClass('ativo');

				mapa = new Mapa();
				mapa.onLoad = function () {
					$('#mapa_ocorrencias .carregando').removeClass('ativo');
					Radar.ocorrencias.mapa.inserirOcorrencias();
				};
				mapa.carregar(document.getElementById('mapa_canvas'));

				Radar.ocorrencias.mapa.set(mapa);
			} else {
				google.maps.event.trigger(Radar.ocorrencias.mapa.get().map, 'resize');
			}

			if (Radar.ocorrencias.dao.getAll().length < 1) {
				Radar.panel.ocorrencias.onLoad();
			}
		}
	},

	filtro: {
		onLoad: function () {
			var wd = $('html').width();
			$('#filtro_ocorrencias').width(wd);
			wd -= 40;
			$('#filtro_ocorrencias ul').width(wd);
			$('#filtro_ocorrencias .btn').width(wd);
		}
	},

	pais: {
		onLoad: function () {
			//console.log("paises: "+Radar.lang);
			if (!$('#pais').hasClass('slidered')) {

				$.getJSON(Radar.app.SITE + "?pg=listapaises&tmpl=component&lang=" + Radar.lang, function (data) {
					if (data.response)
						data = JSON.parse(data.response);

					var ul = $('#pais #carousel');
					//console.log(JSON.stringify(data));
					Cookie.set('paises', JSON.stringify(data));

					for (var i = 0; i < data.length; i++) {
						var pais = data[i];
						if (pais.ativo == '1') {
							ul.append('<div class="carousel_page"><h2>' + langValue(pais.nome) + '</h2><img onclick="usuario.pais(' + pais.id + ')" width="90%" src="' + Radar.app.SITE + '/radarweb/images/paises/' + pais.alias + '.png"/></div>');
						}
					}

					var options = {
						vertical: false,
						horizontal: true,
						pagingDiv: "carousel_dots",
						pagingCssName: "carousel_paging",
						pagingCssNameSelected: "carousel_paging_selected",
						wrap: true
					};

					var carousel = $("#carousel").carousel(options);
					var pages = $("#carousel .carousel_page");
					pages.each(function (index, element) {
						var h = ($(window).height() / 2) - ($(element).height() / 2) - 100;
						$(element).css('margin-top', h + 'px');
					});

					$('#pais .carregando').removeClass('ativo');
					$('#pais').addClass('slidered');

				}).fail(function (error) {
					console.log("Não foi possivel adquirir informações remotas sobre o pais. ");
					//console.log(error);
					console.log(Radar.app.SITE + "?pg=listapaises&tmpl=component");
				});
			}
		}
	},


	selecionar_estado: {
		onLoad: function () {
			var url = Radar.app.SITE + "?pg=listaestados&tmpl=component&pais=" + usuario.dados.pais.id;

			$.getJSON(url, function (data) {
				if (data) {
					Cookie.set('estados', JSON.stringify(data));
					var htmlestados = '';
					for (var i = 0; i < data.length; i++) {
						if (data[i].ativo != "0") {
							htmlestados += '<li onclick="Radar.cidades.selecionarEstado(this)" data-value="' + data[i].id + '"><div class="flaticon-chevrons">' + data[i].nome + '</div></li>';
						}
					}
					$('#selecionar_estado .lista').html(htmlestados);
				}

				$('#selecionar_estado .carregando').removeClass('ativo');


				var estadosli = $('#selecionar_estado .lista li');
				estadosli.removeClass('selecionado');
				if (usuario.dados.estado) {
					estadosli.each(function () {
						if (this.getAttribute('data-value') == usuario.dados.estado.id) {
							$(this).addClass('selecionado');
							return false;
						}
					});
				}

				Radar.cidades.deleteScroll();
				Radar.cidades.scroller = new IScroll('#estado_wrapper', {
					click: true
				});

			}).fail(function () {
				console.log("Não foi possivel adquirir informações sobre estados.");
				console.log(Radar.app.SITE + "?pg=listapaises&tmpl=component");
			});

		}
	},

	info_cidade_estado: {
		onLoad: function () {
			/*if(usuario.dados.pais) {
				$('.userpais .ctr').text(usuario.dados.pais.nome);
			}*/
			/*if(usuario.dados.estado) {
				$('#btn_selecionar_estado').text(usuario.dados.estado.nome);
				$('#btn_selecionar_cidade').show();
			} else {
				$('#btn_selecionar_cidade').hide();
				if(Radar.strings)
					$('#btn_selecionar_estado').text(langValue("select_state"));
			}
			
			if(usuario.dados.cidade) {
				$('#btn_selecionar_cidade').text(usuario.dados.cidade.nome);
			} else {
				if(Radar.strings)
					$('#btn_selecionar_cidade').text(langValue("select_city"));
			}
			
			if(usuario.dados.pais && usuario.dados.estado && usuario.dados.cidade){
				$('#btn_confirmar_cidade_estado').show();
				$('#loading-loc, #info_cidade_estado .message.atencao').hide();
			} else {
				$('#btn_confirmar_cidade_estado').hide();
			}*/
			Radar.cidades.atualizarViews();
		}
	},


	ocorrencias: {
		onLoad: function () {
			Radar.ocorrencias.lista.mostrarCarregando();

			// ajusta a tela de filtro
			Radar.panel.filtro.onLoad();

			if (Radar.ocorrencias.lista.isMapaAtivo) {
				Radar.ocorrencias.lista.verMapa(Radar.ocorrencias.lista.mapaAtivoOID);
			}

			if (!Radar.tipos.dao.carregado) {
				// carrega os tipos
				Radar.tipos.dao.carregar(function (success) {
					if (success) {
						//carrega a lista de ocorrencias
						Radar.ocorrencias.download(10, function (success) {
							if (success) {
								Radar.ocorrencias.lista.adicionar(10);
							} else {
								console.log("Não foi possivel adquirir informações sobre ocorrencias.");
								Radar.ocorrencias.lista.nenhuma(langValue('occurrences_none'));
							}
							Radar.ocorrencias.lista.ocultarCarregando();
							if (Radar.ocorrencias.mapa.get()) {
								Radar.ocorrencias.mapa.get().removerMarcadores();
								Radar.ocorrencias.mapa.inserirOcorrencias();
							}
						});
					}
				});
			} else {
				if (!Radar.ocorrencias.lista.detalhando) {
					if (Radar.ocorrencias.lista.ocorrencia_atual == 0) {
						//carrega a lista de ocorrencias
						Radar.ocorrencias.download(10, function (success) {
							if (success) {
								Radar.ocorrencias.lista.adicionar(10);
							} else {
								console.log("Não foi possivel adquirir informações sobre ocorrencias.");
								Radar.ocorrencias.lista.nenhuma(langValue('occurrences_none'));
							}
							Radar.ocorrencias.lista.ocultarCarregando();
						});
					} else {
						Radar.ocorrencias.lista.adicionar(Radar.ocorrencias.lista.ocorrencia_atual);
					}
				} else {
					Radar.ocorrencias.lista.detalhando = false;
				}
			}
		}
	}

};


var Cookie = {
	set: function (name, value, expirationdays) {

		// caso não deva expirar deve-se usar -1
		if (expirationdays === undefined) expirationdays = -1;

		try {
			/*if (name.indexOf('.') == -1) {
				intel.xdk.cache.setCookie(name, value, expirationdays);
			} else {
				console.log('Nome de cookie não deve incluir um periodo.');
			}*/
			window.localStorage.setItem(name, value);
		} catch (e) {
			console.log("Erro ao tentar salvar cookie: " + e.message);
		}
	},

	get: function (name, indefinido) {
		//return intel.xdk.cache.getCookie(name) || indefinido;
		return window.localStorage.getItem(name) || indefinido;
	},

	remove: function (name) {
		//intel.xdk.cache.removeCookie(name);
		window.localStorage.removeItem(name);
	}
};

(function (d, s, id) {
	var js, fjs = d.getElementsByTagName(s)[0];
	if (d.getElementById(id)) return;
	js = d.createElement(s);
	js.id = id;
	js.src = "http://connect.facebook.net/pt_BR/sdk.js";
	fjs.parentNode.insertBefore(js, fjs);
}(document, 'script', 'facebook-jssdk'));