function Mapa() {
	this.markers = [];
	this.markercluster;
	this.map;

	this.infobox = new InfoBox({
		content: '<div class="infobox">Teste</div>',
		disableAutoPan: false,
		pixelOffset: new google.maps.Size(-110, -50),
		zIndex: null,
		closeBoxURL: "",
		alignBottom: true
	});
}

Mapa.prototype = {
	onLoad: function () {
		console.log("Mapa carregado.");
	},

	carregar: function (jselement) {
		// mostrar carregando()
		var mapaOptions = {
			center: new google.maps.LatLng(usuario.dados.cidade.latitudecentral, usuario.dados.cidade.longitudecentral),
			zoom: 13,
			mapTypeId: google.maps.MapTypeId.ROADMAP,
			mapTypeControl: false,
			navigationControl: false,
			streetViewControl: false,
			zoomControl: false,
			scaleControl: false,
			panControl: false,
			styles: [{
				featureType: "poi",
				elementType: "labels",
				stylers: [{
					visibility: "off"
				}]
			}]
		};

		// adiciona o mapa no elemento
		this.map = new google.maps.Map(jselement, mapaOptions);

		var that = this;
		google.maps.event.addListenerOnce(that.map, 'tilesloaded', function () {
			that.onLoad();
			google.maps.event.trigger(that.map, 'resize');
		});
	},

	removerMarcadores: function () {
		if (this.infobox)
			this.infobox.close();
		for (var i = 0; i < this.markers.length; i++)
			this.markers[i].setMap(null);
		if (this.markercluster)
			this.markercluster.clearMarkers();
		this.markers = [];
	},


	inserirMarcadores: function () {
		if (this.map) {
			if (!this.markercluster) {
				for (var i = 0; i < this.markers.length; i++) {
					this.markers[i].setMap(this.map);
				}
			} else {
				this.markercluster.clearMarkers();
				this.markercluster.addMarkers(this.markers);
			}
		}
	},

	novoMarcador: function (ocorrencia, hasInfobox) {
		var that = this;

		var marcador;

		if (ocorrencia != undefined) {
			var imagem = {
				url: ocorrencia.tipo.getIconUrl(),
				scaledSize: new google.maps.Size(30, 48)
			};

			var ocinfotext = ocorrencia.descricao.length > 45 ? ocorrencia.descricao.substr(0, 45) + '...' : ocorrencia.descricao;

			marcador = new google.maps.Marker({
				position: new google.maps.LatLng(ocorrencia.endereco.latitude, ocorrencia.endereco.longitude),
				id: ocorrencia.id,
				icon: imagem
			});

			if (hasInfobox) {
				marcador.infoboxContent = '<div class="infobox" onclick="Radar.ocorrencias.lista.detalhes(' + ocorrencia.id + ');"><div class="text">' + ocinfotext + '</div><div class="abrir flaticon-chevrons"></div></div><div class="arrow-down"></div>';

				google.maps.event.addListener(marcador, 'click', function () {
					that.infobox.setContent(this.infoboxContent);
					that.infobox.open(that.map, this);
					that.map.panTo(this.position);
				});
			} else {
				google.maps.event.addListener(marcador, 'click', function () {
					that.map.panTo(this.position);
				});
			}
		} else {
			marcador = new google.maps.Marker();
		}
		this.markers.push(marcador);

		return marcador;
	},


	addMarkerCluster: function () {
		if (!this.markercluster) {
			var mcOptions = {
				gridSize: 50,
				maxZoom: 12
			};
			this.markercluster = new MarkerClusterer(this.map, this.markers, mcOptions);
		}
	},

	getEndereco: function (latlng, callback) {
		var geocoder = new google.maps.Geocoder();
		geocoder.geocode({
			'latLng': latlng
		}, function (results, status) {
			if (status == google.maps.GeocoderStatus.OK) {
				if (results[0]) {
					var endereco = results[0].address_components;
					//console.log(JSON.stringify(results));

					var endereco_retorno = {};
					//console.log(JSON.stringify(endereco));
					for (var i = endereco.length - 1; i >= 0; i--) {
						for(var j=0; j < endereco[i].types.length; j++ ){
							// logradouro			
							if (endereco[i].types[j] == 'route') {
								endereco_retorno.logradouro = endereco[i].long_name;
							}
							
							if (endereco[i].types[j] == 'neighborhood' || endereco[i].types[0] == 'sublocality_level_1' || endereco[i].types[j] == 'sublocality') {
								endereco_retorno.bairro = endereco[i].long_name;
							}
							
							if (endereco[i].types[j] == 'street_number') {
								endereco_retorno.numero = endereco[i].long_name;
							}	
						}
					}
				}
			}
			callback(endereco_retorno);
		});
	}
};