Radar.novaOcorrencia = {
	imagens: [],
	tipo: undefined,
	scroller: undefined,
	scroller_tipo: undefined,
	localizacao: {
		latitude: 0,
		longitude: 0,
		endereco: ""
	},

	uploadPublish: function () {
		if (Radar.novaOcorrencia.validar()) {
            Radar.novaOcorrencia.publicar();
		}
	},

	deleteScroll: function () {
		if (this.scroller) {
			this.scroller.destroy();
			this.scroller = null;
		}
	},

	deleteScrollTipo: function () {
		if (this.scroller_tipo) {
			this.scroller_tipo.destroy();
			this.scroller_tipo = null;
		}
	},

	galeriaFoto: function () {
		navigator.camera.getPicture(
			function (imageData) { //sucesso - imageData = imagem em base64
				Radar.novaOcorrencia.exibirFoto(imageData);
			},
			function (message) { //erro
				console.log('Não foi possivel selecionar foto: ' + message);
			}, {
				quality: 65,
				destinationType: Camera.DestinationType.DATA_URL,
				sourceType: navigator.camera.PictureSourceType.PHOTOLIBRARY,
				encodingType: Camera.EncodingType.JPEG,
				targetWidth: 800,
				correctOrientation: true
			});
	},



	tirarFoto: function () {
		navigator.camera.getPicture(
			function (imageData) { //sucesso - imageData = imagem em base64
				Radar.novaOcorrencia.exibirFoto(imageData);
			},
			function (message) { //erro
				console.log('Não foi possivel selecionar foto: ' + message);
			}, {
				quality: 65,
				destinationType: Camera.DestinationType.DATA_URL,
				sourceType: navigator.camera.PictureSourceType.CAMERA,
				encodingType: Camera.EncodingType.JPEG,
				targetWidth: 800,
				correctOrientation: true
			});
	},

	exibirFoto: function (data) {
		$('#cadastrar .foto').addClass('ativo');
		$('#cadastrar .foto img').get(0).src = 'data:image/jpeg;base64,' + data;
		$('#cadastrar #noc_foto').text(langValue('photo_change'));
		Radar.novaOcorrencia.imagens[0] = data;
	},

	exibirTipos: function () {
		var html = '';

		var tipos = Radar.tipos.dao.getAll();
		for (var i = 0; i < tipos.length; i++) {
			var obj = tipos[i];
			var classe = '';

			if (obj == this.tipo) {
				classe = 'class="selecionado"';
			}

			html += '<li data-id="' + obj.id + '" ' + classe + ' onclick="Radar.novaOcorrencia.selecionarTipo(this);"><div><img src="' + obj.getIconUrl() + '"/>' + obj.nome + '</div></li>';
		}

		$('#cadastrar_tipo .lista').get(0).innerHTML = html;

		Radar.app.goToPage('cadastrar_tipo');

		this.deleteScrollTipo();
		this.scroller_tipo = new IScroll('#cadastrar_tipo_wrapper', {
			click: true
		});
	},


	selecionarTipo: function (element) {
		$('#cadastrar_tipo .lista li').removeClass('selecionado');
		$(element).addClass('selecionado');
	},


	confirmarTipo: function () {
		var tipo_selecionado = undefined;

		$("#cadastrar_tipo .lista .selecionado").each(function () {
			tipo_selecionado = Radar.tipos.dao.getById(parseInt(this.getAttribute('data-id')));
			return false;
		});

		if (tipo_selecionado != undefined) {
			this.tipo = tipo_selecionado;

			$('#noc_tipo')
				.text(this.tipo.nome)
				.removeClass("flaticon-printed2");

			$('#noc_tipo_img')
				.show()
				.attr('src', this.tipo.getIconUrl());

			this.deleteScrollTipo();
			$('#cadastrar_tipo .lista').html('');
			$.ui.goBack();

			/* var imgmapa = $('#cadastrar .imgmapa');

			if (imgmapa.hasClass('ativo')) {
				imgmapa.dom = $('#cadastrar .imgmapa').get(0);
				if (Radar.novaOcorrencia.tipo) {
					var urlicon = Radar.app.SITE +
						'/radarweb/images/thumb/phpThumb.php?w=45&h=45&src=../../../components/com_radarcidadao/images/tipos/' +
						Radar.novaOcorrencia.tipo.icone + '&f=png';
					urlicon = encodeURIComponent(urlicon);
					imgmapa.dom.src_icone = urlicon;
				} else {
					imgmapa.dom.src_icone = 'loc-sem-tipo';
				}

				imgmapa.dom.src = imgmapa.dom.src_inicio + imgmapa.dom.src_icone + imgmapa.dom.src_fim;
				imgmapa.addClass('ativo');
			} */
		}
	},

	inserirDescricao: function () {
		var element = $('#cadastrar .descricao');
		if (element.hasClass('ativo')) {
			element.removeClass('ativo');
		} else {
			element.addClass('ativo');
		}
	},

	resetar: function () {

		$('#cadastrar_loc').val(langValue('loc')).attr('disabled', 'disabled');
		//if ($('#noc_imgmapelement').attr('onclick')) {
		//	$('#noc_selectloc').attr('onclick', $('#noc_imgmapelement').attr('onclick')).find('.hasChild').show();
		//}

		document.getElementById('noc_imgelement').src = "";
		//document.getElementById('noc_imgmapelement').src = "";
		document.getElementById('noc_descricao').value = "";
		document.getElementById('noc_tipo').innerText = langValue('category');

		$('#cadastrar .foto').removeClass("ativo");
		//$('#cadastrar #noc_imgmapelement').removeClass("ativo");
		$('#noc_tipo').addClass("flaticon-printed2");
		$('#noc_tipo_img').hide().attr('src', "");
		$('#cadastrar .form').removeClass('fotografar');
		$('#noc_foto').text(langValue('take_picture'));

		$('#noc_descricao').removeClass('ativo');
		$('#noc_desc p').addClass('ativo').focus();

		this.imagens = [];
		this.tipo = undefined;
		this.localizacao = {
			latitude: 0,
			longitude: 0,
			endereco: "",
		};
	},

	share: function () {
		var btnshare = $('#ocorrencia_cadastrada .btn.share');

		if (btnshare.data('id')) {
			var url = Radar.app.SITE + "/" + usuario.dados.cidade.nome + "/" + usuario.dados.estado.uf + "/detalhes/" + btnshare.data('id').trim();
			Radar.app.share(langValue('appName'), btnshare.data('descricao'), url);
		} else {
			navigator.notification.alert(
				langValue('shareocnotpossible'), // message
				false, // callback
				langValue('share'), // title
				'OK' // buttonName
			);
		}
	}
};

Radar.novaOcorrencia.buscarLocalizacao = function () {
	$('#cadastrar_mapa .carregando').addClass('ativo');

	var city = usuario.dados.cidade.nome;
	var state = usuario.dados.estado.nome;
	var endereco = $('cad_endereco_input').val();

	var geocoder = new google.maps.Geocoder();

	geocoder.geocode({
		'address': endereco + ',' + city + ', ' + state,
		componentRestrictions: {
			country: usuario.dados.pais.nome
		}
	}, function (results, status) {

		if (results[0] && results[0].geometry && results[0].geometry.location) {

			if (results[0].geometry.location.lat() && results[0].geometry.location.lng()) {
				var latitude = results[0].geometry.location.lat();
				var longitude = results[0].geometry.location.lng();
				Radar.novaOcorrencia.setLocalizacao(latitude, longitude);
			} else {
				navigator.notification.alert(
					langValue('addressnotfound'), // message
					false, // callback
					langValue('loc'), // title
					'OK' // buttonName
				);
			}
		} else {
			navigator.notification.alert(
				langValue('addressnotfound'), // message
				false, // callback
				langValue('loc'), // title
				'OK' // buttonName
			);
		}
		$('#cadastrar_mapa .carregando').removeClass('ativo');
	});
};

Radar.novaOcorrencia.habilitarDescricao = function () {
	$('#noc_descricao').addClass('ativo').focus();
	$('#noc_desc p').removeClass('ativo');
};


Radar.novaOcorrencia.mapa = undefined;
Radar.novaOcorrencia.marcador = undefined;
Radar.novaOcorrencia.carregarLocalizacao = function () {
	//console.log("localizacao sendo carregada");

	//this.localizacao.bairro = '';
	//this.localizacao.logradouro = '';
	//this.localizacao.numero = '';

	if (!this.mapa) {
		var carregando_element = $('#cadastrar_mapa .carregando');
		carregando_element.addClass('ativo');

		this.mapa = new Mapa();
		this.mapa.onLoad = function () {
			carregando_element.removeClass('ativo');
			Radar.novaOcorrencia.setLocalizacao(usuario.latitude, usuario.longitude);
			Radar.novaOcorrencia.mapa.map.setCenter(new google.maps.LatLng(usuario.latitude, usuario.longitude));
		}

		this.mapa.carregar(document.getElementById('cadastrar_mapa_canvas'));

		this.marcador = this.mapa.novoMarcador();

		if (Radar.novaOcorrencia.tipo != undefined) {
			this.marcador.setIcon({
				url: Radar.novaOcorrencia.tipo.getIconUrl(),
				scaledSize: new google.maps.Size(30, 48)
			});
		}

		google.maps.event.addDomListener(this.mapa.map, 'click', function (location) {
			if (location.latLng.lat() && location.latLng.lng() != 0) {
				Radar.novaOcorrencia.setLocalizacao(location.latLng.lat(), location.latLng.lng());
			} else {
				console.log("As coordenadas não estão funcionando: " + location.latLng.lat() + ", " + location.latLng.lng());
			}
		});

		google.maps.event.trigger(this.mapa.map, 'resize');

		this.mapa.inserirMarcadores();

		if (usuario.latitude && usuario.longitude) {
			Radar.novaOcorrencia.setLocalizacao(usuario.latitude, usuario.longitude);
		} else {
			if (usuario.dados.latitude && usuario.dados.longitude) {
				Radar.novaOcorrencia.setLocalizacao(usuario.dados.latitude, usuario.dados.longitude);
			}
		}
	} else {
		if (Radar.novaOcorrencia.tipo != undefined) {
			this.marcador.setIcon({
				url: Radar.novaOcorrencia.tipo.getIconUrl(),
				scaledSize: new google.maps.Size(30, 48)
			});
		}
	}

}

Radar.novaOcorrencia.selecionarLocalizacao = function () {
	Radar.novaOcorrencia.carregarLocalizacao();
	Radar.app.goToPage('cadastrar_mapa');
};

Radar.novaOcorrencia.tempLocalizacao = {};
Radar.novaOcorrencia.setLocalizacao = function (lat, lng) {

	var coords = new google.maps.LatLng(lat, lng);
	Radar.novaOcorrencia.marcador.setPosition(coords);
	Radar.novaOcorrencia.mapa.map.panTo(coords);

	Radar.novaOcorrencia.tempLocalizacao.latitude = lat;
	Radar.novaOcorrencia.tempLocalizacao.longitude = lng;

	Radar.novaOcorrencia.mapa.getEndereco(coords, function (endereco) {
		var endereco_string = "";
		if (endereco.logradouro) {
			endereco_string += endereco.logradouro;
			Radar.novaOcorrencia.tempLocalizacao.logradouro = endereco.logradouro;
		}
		if (endereco.numero) {
			endereco_string += ', ' + endereco.numero;
			Radar.novaOcorrencia.tempLocalizacao.numero = endereco.numero;
		}
		if (endereco.bairro) {
			endereco_string += ', ' + endereco.bairro;
			Radar.novaOcorrencia.tempLocalizacao.bairro = endereco.bairro;
		} else {
			Radar.novaOcorrencia.tempLocalizacao.bairro = "";
		}
		Radar.novaOcorrencia.tempLocalizacao.endereco = endereco_string;

		if (endereco_string.indexOf('Unnamed Road') == -1) {
			document.getElementById('cad_endereco_input').value = endereco_string;
		} else {
			document.getElementById('cad_endereco_input').value = '';
		}

		$('#cadastrar_mapa .btn').show();

		$('#cadastrar_mapa .carregando').removeClass('ativo');
	});
};

Radar.novaOcorrencia.confirmarLocalizacao = function () {
	Radar.novaOcorrencia.localizacao = JSON.parse(JSON.stringify(Radar.novaOcorrencia.tempLocalizacao));

	var lat = Radar.novaOcorrencia.localizacao.latitude;
	var lng = Radar.novaOcorrencia.localizacao.longitude;
	var devwidth = $('html').width();
	var size = devwidth + 'x' + Math.round(devwidth / 2);

	//var imgmapa = $('#cadastrar .imgmapa');
	//imgmapa.dom = $('#cadastrar .imgmapa').get(0);
	//imgmapa.dom.src_inicio = 'http://maps.google.com/maps/api/staticmap?center=' + lat + ',' + lng + '&markers=icon:';

	if (Radar.novaOcorrencia.tipo) {
		var urlicon = Radar.app.SITE +
			'/radarweb/images/thumb/phpThumb.php?w=45&h=45&src=../../../components/com_radarcidadao/images/tipos/' +
			Radar.novaOcorrencia.tipo.icone + '&f=png';
		urlicon = encodeURIComponent(urlicon);
		//imgmapa.dom.src_icone = urlicon;
	} //else {
		//imgmapa.dom.src_icone = 'loc-sem-tipo';
	//}

	/* imgmapa.dom.src_fim = '|' + lat + ',' + lng + '&zoom=15&size=' + size + '&sensor=false';
	imgmapa.dom.src = imgmapa.dom.src_inicio + imgmapa.dom.src_icone + imgmapa.dom.src_fim;
	imgmapa.addClass('ativo'); */

	var cadastrar_loc = $('#cadastrar #cadastrar_loc');

	if (Radar.novaOcorrencia.localizacao.endereco && Radar.novaOcorrencia.localizacao.endereco.indexOf('Unnamed Road') == -1) {
		cadastrar_loc.val(Radar.novaOcorrencia.localizacao.endereco);
	} else {
		cadastrar_loc.val('').removeAttr('disabled');
		//var imgmapa = $('#noc_imgmapelement');
		var wrapmapa = $('#noc_selectloc');
		//imgmapa.attr('onclick', wrapmapa.attr('onclick'));
		wrapmapa.removeAttr('onclick').find('.hasChild').hide();


		navigator.notification.alert(
			langValue('addressnotfoundtext'), // message
			false, // callback
			langValue('addressnotfound'), // title
			'OK' // buttonName
		);

	}

	Radar.app.goToPage('cadastrar', true);

};

Radar.novaOcorrencia.validar = function () {
	var result = true;

	var descricao = $('#noc_desc');
	var tipo = $('#noc_tipo');
	var localizacao = $('#noc_selectloc');

	if ($('#noc_descricao').val() == '') {
		descricao.addClass('invalido');
		result = false;
	}

	if (Radar.novaOcorrencia.tipo == undefined) {
		tipo.addClass('invalido');
		result = false;
	}

	var nloc = Radar.novaOcorrencia.localizacao;

	if (!nloc.bairro) nloc.bairro = '';
	if (!nloc.logradouro) nloc.logradouro = '';
	if (!nloc.numero) nloc.numero = '';
	if (!nloc.endereco) nloc.endereco = '';

	if ($('#cadastrar_loc').val()) {
		Radar.novaOcorrencia.localizacao.endereco = $('#cadastrar_loc').val();
	}

	if (nloc.logradouro.indexOf('Unnamed Road') > -1 && nloc.endereco.indexOf('Unnamed Road') < 0) {
		Radar.novaOcorrencia.localizacao.logradouro = Radar.novaOcorrencia.localizacao.endereco;
	}

	if (!this.localizacao.endereco && this.localizacao.logradouro) {
		this.localizacao.endereco = this.localizacao.logradouro;
	}

	if (!nloc || nloc.latitude == 0 || nloc.longitude == 0) {
		localizacao.addClass('invalido');
		result = false;
	}

	setTimeout(function () {
		$('#cadastrar .form .invalido').removeClass('invalido');
	}, 400);

	return result;
};

Radar.novaOcorrencia.publicar = function () {
	if (Radar.novaOcorrencia.validar()) {
		$('#cadastrar .carregando').addClass('ativo');

		var time = moment();
		this.descricao = $('#cadastrar #noc_descricao').val();
		if (!usuario.dados.telefone) usuario.dados.telefone = "";

		var postbody = "descricao=" + (this.descricao || '') + "&latitude=" + this.localizacao.latitude + "&longitude=" + this.localizacao.longitude + "&endereco=" + (this.localizacao.endereco || '') + "&numero=" + (this.localizacao.numero || '0') + "&bairro=" + this.localizacao.bairro + "&tipo_id=" + this.tipo.id + "&imgmobile1=" + (this.imagens[0] != null ? this.imagens[0].toString() : "") + "&anonima=0&nomecidadao=" + (usuario.dados.nome || '') + "&fonecidadao=" + (usuario.dados.telefone || '') + "&emailcidadao=" + (usuario.dados.email || '') + "&dataocorrencia_submit=" + time.format('YYYY-MM-DD') + "&horaocorrencia_submit=" + time.format('HH:mm:ss') + "&termos=1" + "&cidade_id=" + usuario.dados.cidade.id;
		//console.log(postbody);

		Radar.app.gerarToken(function (token) {
			postbody += "&" + token + "=1";
			console.log("Token certo:" + token);

			Radar.novaOcorrencia.enviar(postbody, function (e) {
				if (e.success) {
					$('#ocorrencia_cadastrada .num .valor').text(e.ocorrencia_num);
					var btnshare = $('#ocorrencia_cadastrada .btn.share');
					btnshare.data('titulo', langValue('appName'));
					btnshare.data('descricao', Radar.novaOcorrencia.descricao);
					btnshare.data('id', e.ocorrencia_num);
					Radar.novaOcorrencia.resetar();
					Radar.app.goToPage('ocorrencia_cadastrada');
				} else {
					//console.log('Erro: ' + e.mensagem);
					navigator.notification.alert(
						langValue('nocnotpossible'), // message
						false, // callback
						'Erro', // title
						'OK' // buttonName
					);
					//Radar.app.goToPage('ocorrencias');
				}
				$('#cadastrar .carregando').removeClass('ativo');
			});
		});
	}
};


Radar.novaOcorrencia.enviar = function (parametros, callback) {
	$.ajax({
		type: 'POST',
		data: parametros,
		url: Radar.app.SITE + "?pg=cadastro&task=save&tmpl=component&anticache=" + moment().format('YYYY-MM-DD HH:mm:ss'),
		cache: false,

		success: function (resposta) {
			var json_resposta;
			try {
				json_resposta = JSON.parse(resposta);
			} catch (error) {
				json_resposta = {
					msg: '',
					erro: 1,
					numocorrencia: -1
				};
				console.log("Erro ao converter json.");
			}

			callback({
				mensagem: json_resposta.msg,
				success: (json_resposta.erro == 1 ? false : true),
				ocorrencia_num: json_resposta.numocorrencia
			});
		},

		error: function (request, status, error) {
			callback({
				mensagem: "Erro ao tentar adquirir dados remotos.",
				success: false,
				ocorrencia_num: -1
			});
		}
	});
};


Radar.app.gerarToken = function (callback) {
	$.ajax({
		type: 'POST',
		url: Radar.app.SITE + "?pg=token&tmpl=component&cidade_id=" + usuario.dados.cidade.id + "&anticache=" + moment().format('YYYY-MM-DD HH:mm:ss'),

		success: function (resposta) {
			var token = resposta;
			callback(token);
		},

		error: function (request, status, error) {
			console.log("Não foi possivel gerar um token.");
		}
	});
};