function Ocorrencia() {
	this.id;
	this.descricao;
	this.anonima = false;
	this.imagem;
	this.imagens = [];
	this.endereco;
	this.tipo;
	this.data_cadastro;
	this.data_ocorrencia;
	this.cidadao;
	this.respostas = [];
	this.comentarios = [];
	this.situacao;
}

Ocorrencia.prototype = {

	toHtml: function () {
		var dt = moment(this.data_cadastro, "YYYY-MM-DD HH:ss:S");
		var descv = false;
		var btnmais = false;

		if (this.descricao.length > 50) {
			descv = this.descricao.substr(0, 50);
			descv = descv.substr(0, descv.lastIndexOf(" ")) + "...";
			btnmais = true;
		} else {
			descv = this.descricao;
		}

		var endclass = btnmais ? 'reducedwidth' : '';
		var tempbairro = this.endereco.bairro ? ' | ' + this.endereco.bairro : '';

		var html = ['<div class="ocorrencia" id="ocorrencia', this.id + '',
					'"><div class="header"><img class="icone" src="', this.tipo.getIconUrl() + '',
					'"><h5 class="categoria">', this.tipo.nome + '',
					'</h5><h4 class="tempo flaticon-clock221">', dt.fromNow() + '',
					'</h4></div><div class="conteudo"><h3 class="descricao">', descv,
					'</h3><h5 class="endereco ', endclass, '">', this.endereco.logradouro + '', ', ',
					this.endereco.numero + '', tempbairro, '</h5>'
		];

		if (btnmais) {
			html.push('<h5 class="btnmais" onclick="Radar.ocorrencias.lista.verDescricao(', this.id + '', ');">| ' + langValue('ver+') + '</h5>');
		}

		html.push('</div>');

		if (this.situacao.alias) {
			this.situacao.text = langValue(this.situacao.alias);
		} else {
			this.situacao.text = this.situacao.status;
		}

		if (this.imagem) {
			html.push('<div class="imagem"><img src="',
				Radar.app.SITE, '/radarweb/images/thumb/phpThumb.php?zc=1&w=',
				usuario.dados.deviceWidth + "",
				'&h=200&src=../../images/ocorrencias/', usuario.dados.cidade.alias, '/',
				this.imagem + "", '" width="', usuario.dados.deviceWidth + "", '" height="200"></div>');
		}
		
		// html.push('<div class="menu"><table class="horizontal_menu" cellspacing="0" cellpadding="0"><tr><td class="btncomentario" onclick="Radar.ocorrencias.lista.comentarios(', this.id + "", ');">' + langValue('comments') + '</td><td class="separator"><div></div></td><td class="btnmapa" onclick="Radar.ocorrencias.lista.verMapa(', this.id + "", ')">' + langValue('map') + '</td><td class="separator"><div></div></td><td style="color:', this.situacao.bgcolor + "", ';" class="btnsituacao" onclick="Radar.ocorrencias.lista.respostas(', this.id + "", ')">', this.situacao.text, '</td><td class="separator"><div></div></td><td class="btnshare flaticon-social24" onclick="Radar.ocorrencias.lista.compartilhar(', this.id + "", ')"></td></tr></table></div><div class="menu_frame"></div></div>');
		html.push('<div class="menu"><table class="horizontal_menu" cellspacing="0" cellpadding="0"><tr><td class="btnmapa" onclick="Radar.ocorrencias.lista.verMapa(', this.id + "", ')">' + langValue('map') + '</td><td class="separator"><div></div></td><td style="color:', this.situacao.bgcolor + "", ';" class="btnsituacao" onclick="Radar.ocorrencias.lista.respostas(', this.id + "", ')">', this.situacao.text, '</td><td class="separator"><div></div></td><td class="btnshare flaticon-social24" onclick="Radar.ocorrencias.lista.compartilhar(', this.id + "", ')"></td></tr></table></div><div class="menu_frame"></div></div>');

		return html.join('');
	},

	addResposta: function (resposta) {
		if (resposta.id != null) {
			var existente = false;
			for (var i = 0; i < this.respostas.length; i++) {
				if (this.respostas[i].id == resposta.id) {
					existente = true;
					break;
				}
			}
			if (!existente)
				this.respostas.push(resposta);
		}
	},

	addComentario: function (comentario) {
		if (comentario.id) {
			var existente = false;
			for (var i = 0; i < this.comentarios.length; i++) {
				if (this.comentarios[i].id == comentario.id) {
					existente = true;
					break;
				}
			}
			if (!existente)
				this.comentarios.push(comentario);
		}
	},

	getUrl: function () {
		return Radar.app.SITE + "/" + usuario.dados.cidade.nome + "/" + usuario.dados.estado.uf + "/detalhes/" + this.id;
	}
};

Radar.ocorrencias = {
	//loadmore: true,
	download: function (qtde, callback) {
		if (qtde <= 0) {
			if (callback) callback(false);
			return false;
		}

		var
			ini = Radar.ocorrencias.dao.getAll().length, //Radar.ocorrencias.lista.ocorrencia_atual,
			status = Radar.ocorrencias.filtro.situacao.status || '',
			tipo = Radar.ocorrencias.filtro.tipo.id || '',
			palavrachave = Radar.ocorrencias.filtro.palavra_chave || '',
			cidade = usuario.dados.cidade.id,
			data = Radar.ocorrencias.filtro.data || '';

		if (!Radar.ocorrencias.filtro.ativo) {
			status = '';
			tipo = '';
			palavrachave = '';
			data = '';
		}

		var url = Radar.app.SITE + '?pg=listaocorrencias2&tmpl=component&ini=' + ini + '&limit=' + qtde +
			'&status=' + status +
			'&tipo=' + tipo +
			'&cidade=' + cidade +
			'&texto_busca=' + palavrachave +
			'&daterange=' + data;

		$.getJSON(url, function (data) {
			for (var i = 0; i < data.length; i++) {
				var ocorrencia = new Ocorrencia();
				ocorrencia.id = data[i].id;
				ocorrencia.descricao = data[i].descricao;
				ocorrencia.imagem = data[i].foto1;
				ocorrencia.data_cadastro = data[i].datacadastro;
				ocorrencia.endereco = {
					latitude: data[i].latitude,
					longitude: data[i].longitude,
					logradouro: data[i].endereco,
					numero: data[i].numero,
					bairro: data[i].bairro
				};
				ocorrencia.tipo = Radar.tipos.dao.getById(parseInt(data[i].tipo_id));
				ocorrencia.situacao = Radar.situacoes.dao.getByStatus(data[i].status);
				ocorrencia.cidadao = {
					nome: data[i].nomecidadao
				};
				if (!ocorrencia.cidadao.nome)
					ocorrencia.anonima = true;

				Radar.ocorrencias.dao.add(ocorrencia);
			}
			if (callback)
				callback(data.length > 0);

		}).fail(function () {
			if (callback) callback(false);
		});
	}
};

Radar.ocorrencias.dao = {
	itens: [],
	ultima_ocorrencia: 0,

	resetar: function () {
		this.itens = [];
	},

	getById: function (id) {
		var result = undefined;
		for (var i = 0; i < this.itens.length; i++) {
			if (this.itens[i].id == id) {
				result = this.itens[i];
				break;
			}
		}
		return result;
	},

	add: function (ocorrencia) {
		if (ocorrencia.id !== undefined) {
			var existente = false;
			for (var i = 0; i < this.itens.length; i++) {
				if (this.itens[i].id == ocorrencia.id) {
					existente = true;
					break;
				}
			}
			if (!existente) {
				this.itens.push(ocorrencia);
				if (ocorrencia.id > this.ultima_ocorrencia)
					this.ultima_ocorrencia = ocorrencia.id
				return true;
			}
			return false;
		}
	},

	getAll: function () {
		return this.itens;
	},

	get: function (index) {
		return this.itens[index];
	}
};

// controller lista de ocorrencias
Radar.ocorrencias.lista = {
	scroll_ocorrencias: undefined,
	ocorrencia_atual: 0,
	mapa: undefined,
	detalhando: false, // id da ocorrencia a ser exibida sozinha

	adicionar: function (qtde) {
		var ocorrencias = Radar.ocorrencias.dao.getAll();
		var objetivo = this.ocorrencia_atual + qtde;
		var html = '';

		for (var i = this.ocorrencia_atual; i < ocorrencias.length; i++) {
			html += Radar.ocorrencias.dao.get(i).toHtml();
			this.ocorrencia_atual++;
		}

		document.getElementById('lista_ocorrencia').innerHTML += html;

		if (ocorrencias.length >= objetivo) {
			$('#ocorrencias .carregando_itens').show();
		} else {
			$('#ocorrencias .carregando_itens').hide();
		}

		if (ocorrencias.length <= 0) {
			Radar.ocorrencias.lista.nenhuma();
		}
		this.ocultarCarregando();
	},

	adicionarInicio: function (ocorrencia) {
		var lista = document.getElementById('lista_ocorrencia');
		var initial_height = lista.offsetHeight;

		lista.innerHTML = ocorrencia.toHtml() + lista.innerHTML;

		// da scroll na posição que estava antes de adicionar item
		var panel = document.getElementById('ocorrencias');
		panel.scrollTop = panel.scrollTop + (lista.offsetHeight - initial_height);
	},

	detalhes: function (id) {
		Radar.ocorrencias.lista.mostrarCarregando();
		this.detalhando = true;
		Radar.ocorrencias.lista.loadmore = false;
		var listaocorrencia = document.getElementById('lista_ocorrencia');
		listaocorrencia.innerHTML = Radar.ocorrencias.dao.getById(id).toHtml();
		$('#ocorrencias .carregando_itens').hide();
		Radar.app.goToPage('ocorrencias');
		this.ocultarCarregando();
	},

	verDescricao: function (id) {
		$('#ocorrencia' + id + " .descricao").text(Radar.ocorrencias.dao.getById(id).descricao);
		$('#ocorrencia' + id + " .btnmais").css('display', 'none');
		$('#lista_ocorrencia #ocorrencia' + id + ' .conteudo .endereco').removeClass('reducedwidth');
	},

	mostrarCarregando: function () {
		$('#ocorrencias .carregando').addClass('ativo');
	},

	ocultarCarregando: function () {
		$('#ocorrencias .carregando').removeClass('ativo');
	},

	carregarRespostas: function (id, callback) {
		var url = Radar.app.SITE + '/?pg=listarespostas&id=' + id + '&tmpl=component';

		$.getJSON(url, function (data) {
			if (data.respostas) {
				for (var i = 0; i < data.respostas.length; i++) {
					var resposta = data.respostas[i];

					Radar.ocorrencias.dao.getById(id).addResposta({
						id: parseInt(resposta.id),
						data: resposta.data,
						observacao: resposta.observacao,
						status: resposta.status,
						anexos: [resposta.anexo1, resposta.anexo2]
					});
				}
			}
			if (callback) callback(id, true);
		}).fail(function () {
			if (callback) callback(id, false);
		});
	},

	exibirRespostas: function (id, success) {
		if (success) {
			var menu_frame = $('#ocorrencia' + id + ' .menu_frame');

			var html = '';
			var respostas = [Radar.ocorrencias.dao.getById(id).respostas[0]];

			for (var i = 0; i < respostas.length; i++) {
				var resposta = respostas[i];
				html += '<div class="resposta">';
				html += '<div class="de">' + usuario.dados.cidade.nome + ' | ' + usuario.dados.estado.uf + '</div>';
				html += '<div class="data flaticon-clock221">' + moment(resposta.data, "YYYY-MM-DD HH:ss:S").fromNow() + '</div>';
				html += '<div class="observacao">' + resposta.observacao + '</div>';
				html += '<div class="anexos">'
				if (resposta.anexos[0]) {
					var urlAnexo = Radar.app.SITE + "/radarweb/images/respostas/" + usuario.dados.cidade.alias + "/" + resposta.anexos[0];
					html += '<div class="anexo an1 flaticon-attachment7"><a onclick="Radar.ocorrencias.lista.baixarAnexo(this);" data-link="' + urlAnexo + '">Anexo 1</a></div>';
				}
				if (resposta.anexos[1]) {
					var urlAnexo = Radar.app.SITE + "/radarweb/images/respostas/" + usuario.dados.cidade.alias + "/" + resposta.anexos[1];
					html += '<div class="anexo an2 flaticon-attachment7"><a onclick="Radar.ocorrencias.lista.baixarAnexo(this);" data-link="' + urlAnexo + '">Anexo 2</a></div>';
				}
				html += '</div>';
				html += '</div>';
			}

			menu_frame.get(0).innerHTML = html;
		}
	},

	baixarAnexo: function (element_n) {
		Radar.app.openUrl(element_n.getAttribute('data-link'));
	},

	carregarComentarios: function (id, callback, url) {
		var ocorrencia = Radar.ocorrencias.dao.getById(id);

		if (!url) {
			var urlocorrencia = Radar.app.SITE + '/' + usuario.dados.cidade.alias + '/' + usuario.dados.estado.uf + '/detalhes/' + id;
			var offset = '&offset=' + ocorrencia.comentarios.length;

			url = 'http://graph.facebook.com/comments/?ids=' + urlocorrencia +
				'&fields=message,from,created_time&limit=5' + offset;

			//url = 'http://graph.facebook.com/comments/?ids=http://www.melhorweb.com.br/artigo/321-Como-inserir-no-seu-site-o-plugin-de-comentarios-do-Facebook.htm&fields=message,from,created_time&limit=5'+offset;
		}

		$.getJSON(url, function (resposta) {
			if (resposta) {
				if (!resposta.data) {
					for (key in resposta) {
						resposta = resposta[key].comments;
						break;
					}
				}

				var data = resposta.data;
				var comentarios = [];

				if (data) {
					for (var i = 0; i < data.length; i++) {
						var comentario = {
							username: data[i].from.name,
							datacriacao: moment(data[i].created_time, "YYYY-MM-DD-HH:ss:S-----"),
							mensagem: data[i].message,
							id: data[i].id
						};
						comentarios.push(comentario);
						ocorrencia.addComentario(comentario);
					}

					if (resposta.paging != undefined && resposta.paging.next != undefined) {
						if (ocorrencia.comentarios_next != resposta.paging.next)
							ocorrencia.comentarios_next = resposta.paging.next;
						else
							ocorrencia.comentarios_next = false;
					} else {
						ocorrencia.comentarios_next = false;
					}
				}

				if (callback) callback(id, true, comentarios);
			} else {
				if (callback) callback(id, false);
			}

		}).fail(function () {
			if (callback) callback(id, false);
		});
	},

	adicionarComentarios: function (id, success, comments) {
		if (success) {
			var menu_frame = $('#ocorrencia' + id + ' .menu_frame');

			var html = '';
			var ocorrencia = Radar.ocorrencias.dao.getById(id);

			if (usuario.dados.logado == 'facebook') {
				var urlocorrencia = Radar.app.SITE + '/' + usuario.dados.cidade.alias + '/' + usuario.dados.estado.uf + '/detalhes/' + id;

				html += '<div class="fb-comments" data-href="' + urlocorrencia + '" data-width="' + ($('html').height()) + '" data-numposts="5" data-mobile="true" data-colorscheme="light"></div>';

				menu_frame.get(0).innerHTML += html;

				FB.XFBML.parse();

				setTimeout(function () {
					if (this.scroll_ocorrencias) {
						this.scroll_ocorrencias.refresh();
						var idf = $('#ocorrencia' + id + ' .menu_frame iframe').attr('id');
						new IScroll('#' + idf);
					}
				}, 1000);
			} else {
				for (var i = 0; i < comments.length; i++) {
					var comentario = comments[i];
					html += '<div class="comentario">';
					html += '<div class="de">' + comentario.username + '</div>';
					html += '<div class="data flaticon-clock221">' + comentario.datacriacao.fromNow() + '</div>';
					html += '<div class="observacao">' + comentario.mensagem + '</div>';
					html += '</div>';
				}

				if (ocorrencia.comentarios.length <= 0) {
					html += '<div class="comentario sqn">' + langValue('nocomments') + '</div>';
				} else {
					if (ocorrencia.comentarios_next) {
						html += '<input value="' + langValue('morecomments') + '" type="button" class="btnmais_comments" onclick="Radar.ocorrencias.lista.carregarComentarios(' + id + ', Radar.ocorrencias.lista.adicionarComentarios);this.parentNode.removeChild(this);"/>';
					}
				}
				menu_frame.get(0).innerHTML += html;
			}
		}
	},

	comentarios: function (id) {
		//caso o mapa esteja aparecendo: desativar
		if ($('#ocorrencia' + id + ' .btnmapa').hasClass('ativo')) {
			this.verMapa(id);
		}

		//caso as respostas estejam aparecendo: desativar
		if ($('#ocorrencia' + id + ' .btnsituacao').hasClass('ativo')) {
			this.respostas(id);
		}

		//caso as respostas estejam aparecendo: desativar
		if ($('#ocorrencia' + id + ' .btnshare').hasClass('ativo')) {
			this.compartilhar(id);
		}

		var btncomentario = $('#ocorrencia' + id + ' .btncomentario');
		var ativo = btncomentario.hasClass('ativo');

		if (ativo) {
			$('#ocorrencia' + id + ' .menu_frame').html('');
			btncomentario.removeClass('ativo').removeClass('loadingdata');
		} else {
			btncomentario.addClass('ativo loadingdata');
			var urlocorrencia = Radar.app.SITE + '/' + usuario.dados.cidade.alias + '/' + usuario.dados.estado.uf + '/detalhes/' + id;
			var html = '<div class="fb-comments" data-href="' + urlocorrencia + '" data-numposts="3" data-mobile="true" data-colorscheme="light"></div>';
			$('#ocorrencia' + id + ' .menu_frame').html(html);

			if (typeof FB != 'undefined') {
				FB.XFBML.parse();

				document.querySelector('#ocorrencia' + id + ' .fb-comments iframe').onload = function () {
					setTimeout(function () {
						var iframes = document.querySelectorAll('#ocorrencia' + id + ' .fb-comments iframe');
						for (var i = 0; i < iframes.length; i++) {
							iframes[i].style.height = iframes[i].contentWindow.document.body.offsetHeight + 'px';
						}
					}, 200);
				}

			} else {
				$('#ocorrencia' + id + ' .menu_frame').html('<p>-</p>');
			}

			setTimeout(function () {
				if (this.scroll_ocorrencias) {
					this.scroll_ocorrencias.refresh();
					var idf = $('#ocorrencia' + id + ' .menu_frame iframe').attr('id');
					new IScroll('#' + idf);
				}
				btncomentario.removeClass('loadingdata');
			}, 1000);
		}
	},

	respostas: function (id) {
		//caso o mapa esteja aparecendo: desativar
		if ($('#ocorrencia' + id + ' .btnmapa').hasClass('ativo')) {
			this.verMapa(id);
		}

		//caso as respostas estejam aparecendo: desativar
		if ($('#ocorrencia' + id + ' .btncomentario').hasClass('ativo')) {
			this.comentarios(id);
		}

		//caso as respostas estejam aparecendo: desativar
		if ($('#ocorrencia' + id + ' .btnshare').hasClass('ativo')) {
			this.compartilhar(id);
		}

		var btnsituacao = $('#ocorrencia' + id + ' .btnsituacao');
		var ativo = btnsituacao.hasClass('ativo');
		if (ativo) {
			$('#ocorrencia' + id + ' .menu_frame').html('');
			btnsituacao.removeClass('ativo').removeClass('loadingdata');
		} else {
			btnsituacao.addClass('ativo loadingdata');
			if (Radar.ocorrencias.dao.getById(id).respostas.length > 0) {
				btnsituacao.removeClass('loadingdata');
				this.exibirRespostas(id, true);
			} else {
				this.carregarRespostas(id, function (crid, crsuccess) {
					btnsituacao.removeClass('loadingdata');
					Radar.ocorrencias.lista.exibirRespostas(crid, crsuccess);
				});
			}
		}
	},

	compartilhar: function (id) {
		//caso o mapa esteja aparecendo: desativar
		if ($('#ocorrencia' + id + ' .btnmapa').hasClass('ativo')) {
			this.verMapa(id);
		}

		//caso as respostas estejam aparecendo: desativar
		if ($('#ocorrencia' + id + ' .btncomentario').hasClass('ativo')) {
			this.comentarios(id);
		}

		//caso as respostas estejam aparecendo: desativar
		if ($('#ocorrencia' + id + ' .btnsituacao').hasClass('ativo')) {
			this.respostas(id);
		}

		var btnshare = $('#ocorrencia' + id + ' .btnshare');
		var ativo = btnshare.hasClass('ativo');
		if (ativo) {
			$('#ocorrencia' + id + ' .menu_frame').html('');
			btnshare.removeClass('ativo');
		} else {
			//btnshare.addClass('ativo');
			//this.exibirShareBtns(id);
			var ocorrencia = Radar.ocorrencias.dao.getById(id);
			Radar.app.share(langValue('appName'), ocorrencia.descricao, ocorrencia.getUrl());
		}
	},

	exibirShareBtns: function (id) {
		var urlpagina = Radar.app.SITE + "/" + usuario.dados.cidade.alias + "/" + usuario.dados.estado.uf + "/detalhes/" + id;
		urlpagina = encodeURIComponent(urlpagina);

		var links = [];
		links['googleplus'] = "https://plus.google.com/share?url=" + urlpagina;
		links['facebook'] = "https://facebook.com/sharer.php?u=" + urlpagina;
		links['twitter'] = "https://twitter.com/intent/tweet?url=" + urlpagina;

		var html = '<div class="sharebtns">';
		html += '<a class="btn-social btn-twitter" onclick="Radar.app.openUrl(\'' + links['twitter'] + '\');">Twitter</a>';
		html += '<a class="btn-social btn-facebook" onclick="Radar.app.openUrl(\'' + links['facebook'] + '\');">Facebook</a>';
		html += '<a class="btn-social btn-google" onclick="Radar.app.openUrl(\'' + links['googleplus'] + '\');">Google+</a>';
		html += '</div>';

		$('#ocorrencia' + id + ' .menu_frame').html(html);
	},

	isMapaAtivo: false,
	mapaAtivoOID: undefined, //ocorrencia que ativou o mapa

	verMapa: function (id) {
		//caso as respostas estejam aparecendo: desativar
		if ($('#ocorrencia' + id + ' .btncomentario').hasClass('ativo')) {
			this.respostas(id);
		}

		//caso as respostas estejam aparecendo: desativar
		if ($('#ocorrencia' + id + ' .btnsituacao').hasClass('ativo')) {
			this.respostas(id);
		}

		//caso as respostas estejam aparecendo: desativar
		if ($('#ocorrencia' + id + ' .btnshare').hasClass('ativo')) {
			this.compartilhar(id);
		}

		Radar.app.goToPage('mapa_ocorrencias');

		var marcadores = Radar.ocorrencias.mapa.get().markers;
		for (var i = 0; i < marcadores.length; i++) {
			if (marcadores[i].id == id) {
				google.maps.event.trigger(marcadores[i], 'click');
				//Radar.ocorrencias.mapa.get().map.setZoom(16);
			}
		}
	}

};

Radar.ocorrencias.lista.scrolling = false;
Radar.ocorrencias.lista.loadmore = true;
Radar.ocorrencias.lista.onScroll = function () {
	if (!this.loadmore) return;
	if (this.scrolling) return;

	this.scrolling = true;

	var scrolled = document.getElementById('ocorrencias').scrollTop;
	var end = document.getElementById('lista_ocorrencia').offsetHeight - (usuario.dados.scrollfrom || 1000);

	if (scrolled >= end) {
		Radar.ocorrencias.lista.onPageEnd();
	}
	Radar.ocorrencias.lista.verificarNovas();

	Radar.ocorrencias.lista.scrolling = false;
};

Radar.ocorrencias.lista.verificandoNovas = false;
Radar.ocorrencias.lista.verificarNovas = function () {
	if (Radar.ocorrencias.lista.verificandoNovas)
		return false;

	Radar.ocorrencias.lista.verificandoNovas = true;

	var
		after = Radar.ocorrencias.dao.ultima_ocorrencia,
		status = Radar.ocorrencias.filtro.situacao.status || '',
		tipo = Radar.ocorrencias.filtro.tipo.id || '',
		palavrachave = Radar.ocorrencias.filtro.palavra_chave || '',
		cidade = usuario.dados.cidade.id,
		data = Radar.ocorrencias.filtro.data || '';

	if (!Radar.ocorrencias.filtro.ativo) {
		status = '';
		tipo = '';
		palavrachave = '';
		data = '';
	}

	var url = Radar.app.SITE + '?pg=listaocorrencias2&tmpl=component&after=' + after + '&limit=100&status=' + status +
		'&tipo=' + tipo +
		'&cidade=' + cidade +
		'&texto_busca=' + palavrachave +
		'&daterange=' + data;

	$.getJSON(url, function (data) {
		var qtdeoc = 0;
		for (var i = 0; i < data.length; i++) {
			var ocorrencia = new Ocorrencia();
			ocorrencia.id = data[i].id;
			ocorrencia.descricao = data[i].descricao;
			ocorrencia.imagem = data[i].foto1;
			ocorrencia.data_cadastro = data[i].datacadastro;
			ocorrencia.endereco = {
				latitude: data[i].latitude,
				longitude: data[i].longitude,
				logradouro: data[i].endereco,
				numero: data[i].numero,
				bairro: data[i].bairro
			};
			ocorrencia.tipo = Radar.tipos.dao.getById(parseInt(data[i].tipo_id));
			ocorrencia.situacao = Radar.situacoes.dao.getByStatus(data[i].status);
			ocorrencia.cidadao = {
				nome: data[i].nomecidadao
			};
			if (!ocorrencia.cidadao.nome)
				ocorrencia.anonima = true;

			if (Radar.ocorrencias.dao.add(ocorrencia)) {
				Radar.ocorrencias.lista.adicionarInicio(ocorrencia);
				qtdeoc++;
			}
		}
		//console.log("terminou de verificar, novas: "+qtdeoc);
		setTimeout(function () {
			Radar.ocorrencias.lista.verificandoNovas = false;
		}, 2000)
	}).fail(function () {
		//console.log("erro verificando");
		setTimeout(function () {
			Radar.ocorrencias.lista.verificandoNovas = false;
		}, 2000)
	});
};

Radar.ocorrencias.lista.onPageEnd = function () {
	Radar.ocorrencias.download(1, function (success) {
		if (success) {
			Radar.ocorrencias.lista.adicionar(1);
			if (Radar.ocorrencias.mapa.get()) {
				Radar.ocorrencias.mapa.get().removerMarcadores();
				Radar.ocorrencias.mapa.inserirOcorrencias();
			}
		} else {
			console.log("Não foi possivel adquirir informações sobre ocorrencias.");
			Radar.ocorrencias.lista.loadmore = false;
		}
	});
};

//controller mapa de ocorrencias
Radar.ocorrencias.mapa = {
	mapobj: undefined,

	/*carregar: function () {
		if (!this.mapobj) {
			var carregando_element = $('#mapa_ocorrencias .carregando');
			carregando_element.addClass('ativo');

			this.mapobj = new Mapa();
			
			this.mapobj.onLoad = function () {
				console.log("mapa carregado");
				carregando_element.removeClass('ativo');
			}

			this.mapobj.carregar($('#mapa_canvas').get(0));
		} else {
			google.maps.event.trigger(this.mapobj.map, 'resize');
		}
	},*/

	inserirOcorrencias: function () {
		var ocorrencias = Radar.ocorrencias.dao.getAll();
		for (var i = 0; i < ocorrencias.length; i++) {
			var ocorrencia = ocorrencias[i];
			this.mapobj.novoMarcador(ocorrencia, true);
		}
		this.mapobj.addMarkerCluster();
		this.mapobj.inserirMarcadores();
	},

	get: function () {
		return this.mapobj;
	},

	set: function (mapa) {
		this.mapobj = mapa;
	}
};

//controller filtro de ocorrencias
Radar.ocorrencias.filtro = {
	scroller: null,
	tipo: {},
	situacao: {},
	palavra_chave: "",
	tipo_selecionado: null,
	situacao_selecionada: null,
	data_selecionada: null,
	data: "",
	visivel: false,
	ativo: false,
	alterando: false,

	ativar: function () {
		Radar.ocorrencias.lista.mostrarCarregando();
		//Radar.ocorrencias.lista.scroll_ocorrencias.scrollTo(0,0,0);

		this.palavra_chave = document.getElementById('filtro_palavrachave').value;
		Radar.ocorrencias.dao.resetar();
		Radar.ocorrencias.lista.limpar();

		if (Radar.ocorrencias.mapa.get())
			Radar.ocorrencias.mapa.get().removerMarcadores();

		this.ativo = true;

		Radar.ocorrencias.download(10, function (success) {
			if (success) {
				Radar.ocorrencias.lista.adicionar(10);
				if (Radar.ocorrencias.mapa.get())
					Radar.ocorrencias.mapa.inserirOcorrencias();
			} else {
				Radar.ocorrencias.lista.nenhuma(langValue('occurrences_none'));
			}
		});
		Radar.app.goToPage('ocorrencias');
		//this.toggle();
	},

	toggle: function () {
		if (this.visivel) {
			$('#filtro_ocorrencias').removeClass('ativo');
			$('header .filtro').removeClass('ativo');
			this.visivel = false;
		} else {
			$('#filtro_ocorrencias').addClass('ativo');
			$('header .filtro').addClass('ativo');
			this.visivel = true;
		}
	},

	deleteScroll: function () {
		if (this.scroller) {
			this.scroller.destroy();
			this.scroller = null;
		}
	},

	confirmarTipo: function () {
		$("#selecionar_tipo_filtro .lista .selecionado").each(function () {
			Radar.ocorrencias.filtro.tipo_selecionado =
				Radar.tipos.dao.getById(parseInt(this.getAttribute('data-id')));
			return false;
		});

		if (this.tipo_selecionado) {
			this.tipo = this.tipo_selecionado;
			$('#filtro_ocorrencias #filtro_tipo').text(this.tipo.nome);
			$.ui.goBack();
		}
		this.deleteScroll();
	},

	confirmarSituacao: function () {
		$("#selecionar_situacao_filtro .lista .selecionado").each(function () {
			Radar.ocorrencias.filtro.situacao_selecionada =
				Radar.situacoes.dao.getById(parseInt(this.getAttribute('data-id')));
			return false;
		});

		if (this.situacao_selecionada) {
			this.situacao = this.situacao_selecionada; //Radar.situacoes.dao.getByStatus(this.situacao_selecionada);
			$('#filtro_ocorrencias #filtro_situacao').text(this.situacao.status);
			$.ui.goBack();
		}
		this.deleteScroll();
	},

	confirmarPeriodo: function () {
		var text;
		$("#filtro_periodos .lista .selecionado").each(function () {
			Radar.ocorrencias.filtro.data_selecionada = this.getAttribute('data-value');
			text = this.innerText;
			return false;
		});

		if (this.data_selecionada) {
			this.data = this.data_selecionada + ' - ' + moment().format('DD/MM/YYYY');
			$('#filtro_ocorrencias #filtro_periodo').text(text);
			$.ui.goBack();
		}

		this.deleteScroll();
	},

	selecionarTipo: function (element) {
		$('#selecionar_tipo_filtro .lista .selecionado').removeClass('selecionado');
		$(element).addClass('selecionado');
	},

	selecionarSituacao: function (element) {
		$('#selecionar_situacao_filtro .lista .selecionado').removeClass('selecionado');
		$(element).addClass('selecionado');
	},

	selecionarPeriodo: function (element) {
		$('#filtro_periodos .lista .selecionado').removeClass('selecionado');
		$(element).addClass('selecionado');
	},

	listarPeriodos: function () {
		this.alterando = true;
		$('#filtro_periodos .lista li').each(function () {
			this.setAttribute('onclick', 'Radar.ocorrencias.filtro.selecionarPeriodo(this);');

			var num = this.getAttribute('data-subtract-num');
			if (num != undefined) {
				var sh = this.getAttribute('data-subtract-sh');
				var data = moment().subtract(num, sh).format('DD/MM/YYYY');
				this.setAttribute('data-value', data);
			} else {
				var data = moment().format('DD/MM/YYYY'); //dia atual
				this.setAttribute('data-value', data);
			}
		});

		Radar.app.goToPage('filtro_periodos');

		this.deleteScroll();
		this.scroller = new IScroll('#filtro_periodo_wrapper', {
			click: true
		});
	},

	listarSituacoes: function () {
		this.alterando = true;
		var html = "";
		var situacoes = Radar.situacoes.dao.getAll();

		for (var i = 0; i < situacoes.length; i++) {
			var situacao = situacoes[i];
			if (situacao.filtravel) {
				var classe = '';

				if (situacao == this.situacao_selecionada) {
					classe = 'class="selecionado"';
				}

				html += '<li data-id="' + situacao.id + '" ' + classe + ' onclick="Radar.ocorrencias.filtro.selecionarSituacao(this);"><div>' + situacao.status + '</div></li>';
			}
		}

		$('#selecionar_situacao_filtro .lista').html(html);

		Radar.app.goToPage('selecionar_situacao_filtro');

		this.deleteScroll();
		this.scroller = new IScroll('#situacao_filtro_wrapper', {
			click: true
		});
	},

	listarTipos: function () {
		this.alterando = true;
		var html = "";
		for (var i = 0; i < Radar.tipos.dao.getAll().length; i++) {
			var tipo = Radar.tipos.dao.getAll()[i];
			var classe = '';

			if (tipo.nome == this.tipo_selecionado) {
				classe = 'class="selecionado"';
			}

			html += '<li data-id="' + tipo.id + '" ' + classe + ' onclick="Radar.ocorrencias.filtro.selecionarTipo(this);"><div><img src="' + tipo.getIconUrl() + '"/>' + tipo.nome + '</div></li>';
		}

		$('#selecionar_tipo_filtro .lista').html(html);

		Radar.app.goToPage('selecionar_tipo_filtro');
		this.deleteScroll();
		this.scroller = new IScroll('#tipo_filtro_wrapper', {
			click: true
		});
	}
};

Radar.ocorrencias.filtro.limpar = function () {
	Radar.ocorrencias.lista.mostrarCarregando();

	this.situacao = {};
	document.getElementById('filtro_situacao').innerText = langValue('situation');

	this.tipo = {};
	document.getElementById('filtro_tipo').innerText = langValue('category');

	this.palavra_chave = '';
	document.getElementById('filtro_palavrachave').value = '';

	this.data = '';
	document.getElementById('filtro_periodo').innerText = langValue('all_posts');

	this.ativo = false;

	Radar.ocorrencias.dao.resetar();
	Radar.ocorrencias.lista.limpar();
	Radar.ocorrencias.filtro.toggle();

	if (Radar.ocorrencias.mapa.get())
		Radar.ocorrencias.mapa.get().removerMarcadores();

	Radar.ocorrencias.download(10, function (success) {
		if (success) {
			Radar.ocorrencias.lista.adicionar(10);
			if (Radar.ocorrencias.mapa.get())
				Radar.ocorrencias.mapa.inserirOcorrencias();
		} else {
			Radar.ocorrencias.lista.nenhuma();
		}
	});
};

Radar.ocorrencias.lista.nenhuma = function (msg) {
	msg = msg || langValue('cityoccurrences_none');
	$('#ocorrencias .carregando_itens').hide();
	document.getElementById('lista_ocorrencia').innerHTML = '<div class="semoc">' + msg + '</div>';
	Radar.ocorrencias.lista.ocultarCarregando();
};

Radar.ocorrencias.lista.limpar = function () {
	document.getElementById('lista_ocorrencia').innerHTML = '';
	this.ocorrencia_atual = 0;
	Radar.ocorrencias.lista.loadmore = true;
};

Radar.ocorrencias.lista.menuOnclick = function () {
	var itenslength = Radar.ocorrencias.lista.ocorrencia_atual;
	Radar.ocorrencias.lista.ocorrencia_atual = 0; //reinicia a contagem que define qual objeto sera adicionado a lista
	Radar.ocorrencias.lista.limpar(); //limpa o html da lista
	Radar.ocorrencias.lista.adicionar(itenslength); //adiciona os itens que ja foram carregados no app
	Radar.app.goToPage('ocorrencias');
};