function Situacao(options){
	this.bgcolor = options.bgcolor;
	this.status = options.status;
	this.id = options.id;
	this.filtravel = options.filtravel;
	this.alias = options.alias;
}

Radar.situacoes = {};

Radar.situacoes.dao = {
	lista: [],
	carregado: false,
	
	carregar : function(callback){		
		this.lista = [];
		var that = this;

		$.getJSON('situacoes.json', function(json_obj){
			$.each(json_obj, function(index, obj){
				var item = new Situacao({
					id: (obj.id ? obj.id : that.lista.length),
					status: obj.status,
					bgcolor: obj.bgcolor,
					filtravel: obj.filtro,
					alias: obj.alias
				});
				
				if(item.alias && Radar.strings){
					item.text = langValue(item.alias);	
				} else {
					item.text = item.status;
				}	
				
				that.lista.push(item);
			});
			that.carregado = true;
			if(callback) callback(true);
			console.log("Situações carregadas.");
			Radar.app.carregamentoCompleto();
		}).fail(function(){
			if(callback) callback(false);	
			console.log("Erro ao carregar as situações.");
		});  
	},
	
	getById: function(id) {
		var obj;
		for(var i=0; i < this.lista.length; i++){
			if(this.lista[i].id == id){
				obj = this.lista[i];
				break;
			}
		}
		return obj;
	},
	
	getByStatus: function(status) {
		var obj;
		for(var i=0; i < this.lista.length; i++){
			if(this.lista[i].status == status){
				obj = this.lista[i];
				break;
			}
		}
		return obj;
	},
	
	get: function(index){
		return this.lista[index];	
	},
	
	getAll: function(){
		return this.lista;	
	},
	
	add: function(obj){
		this.lista.push(obj);
	}
};