var usuario = {

	carregado: false,

	dados: {
		nome: undefined,
		email: undefined,
		telefone: undefined,
		anonimo: false,
		cidade: undefined,
		latitude: undefined,
		longitude: undefined,
		logado: false,
		deviceWidth: 0,
		deviceHeight: 0,
		pais: undefined
	},

	carregar: function () {
		var info = Cookie.get('usuario_dados');

		if (info !== undefined) {
			this.dados = JSON.parse(info);
            
           // console.log(!this.dados.pais);
            if (!this.dados.pais) {
                
                $('#pais').attr('selected', 'selected');
                $('#info_cidade_estado').removeAttr('selected').hide().insertAfter($('#pais'));
                
            } 
            
			//console.log("login feito com sucesso. usuario:" + this.dados.nome)
			$('#cadastrar h2 .login_type').text(this.dados.nome);
			
			Radar.panel.info_cidade_estado.onLoad();
            
		} else {
			console.log("login não definido.")
		}

		this.carregado = true;
		console.log("usuario carregado");
		Radar.app.carregamentoCompleto();
	},

	salvar: function () {
		var json = JSON.stringify(this.dados);
		Cookie.set('usuario_dados', json);
		console.log("usuario salvo");
	},

	tamanhoTela: function () {
		this.dados.deviceHeight = $(window).height();
		this.dados.deviceWidth = $(window).width();
		$('html, #afui').height(this.dados.deviceHeight + 'px');
		this.scrollfrom = this.dados.deviceHeight * 5;
		console.log("tamanho tela: " + this.dados.deviceWidth + "x" + this.dados.deviceHeight);
	},

	// sem callback = assincrono | com callback = sincrono
	localizacao: function (callback) {
		// usuario
		var that = this;

		// sucesso em adquirir localização
		var success = function (p) {
			if (p.coords.latitude != undefined && p.coords.longitude != undefined) {
				that.latitude = p.coords.latitude;
				that.longitude = p.coords.longitude;
			}
			if (callback != undefined) callback(true);
		};

		// falha em adquirir localização
		var fail = function () {
			console.log("Não conseguimos carregar seu endereço automaticamente, pois seu GPS aparentemente está desligado.");
			if (callback != undefined) callback(false);
		};

		navigator.geolocation.getCurrentPosition(success, fail);
	},

	deslogar: function () {
		if (this.dados.logado == "facebook") {
			facebook.logout();
		}

		this.dados.logado = false;

		this.salvar();

		Radar.app.goToPage('login');
	},

	loginAnonimo: function () {
		var elem = $('#login #btn_login_anonimo');
		if (usuario.dados.anonimo) {
			elem.removeClass('ativo');
			this.dados.anonimo = false;
			this.dados.logado = false;
			this.dados.nome = undefined;
			$('#cadastrar h2 .login_type').text('');
		} else {
			elem.addClass('ativo');
			this.dados.anonimo = true;
			this.dados.logado = "anonimo";
			this.dados.nome = "Anonimo";
			$('#cadastrar h2 .login_type').text('anonimo');
			Radar.app.goToPage('cadastrar');
			this.salvar();
		}
	},

	loginEmail: function () {
		this.dados.nome = this.dados.nome || '';
		this.dados.email = this.dados.email || '';
		this.dados.telefone = this.dados.telefone || '';
		$('#login_cadastro_nome').val(this.dados.nome);
		$('#login_cadastro_email').val(this.dados.email);
		$('#login_cadastro_telefone').val(this.dados.telefone);
		Radar.app.goToPage('login_email');
	},

	confirmarLoginEmail: function () {
		this.dados.nome = document.getElementById('login_cadastro_nome').value.trim();
		this.dados.email = document.getElementById('login_cadastro_email').value.trim();
		this.dados.telefone = document.getElementById('login_cadastro_telefone').value.trim();

		if (this.dados.nome !== '' && this.dados.email !== '' && this.dados.telefone !== '') {
			this.dados.logado = "cadastro";
			this.salvar();
			$('#cadastrar h2 .login_type').text(this.dados.nome);
			Radar.app.goToPage('cadastrar');
		} else {
			if (usuario.dados.nome === '')
				$('#login_email form div.nome').addClass('invalido');

			if (usuario.dados.email === '')
				$('#login_email form div.email').addClass('invalido');

			if (usuario.dados.telefone === '')
				$('#login_email form div.telefone').addClass('invalido');

			setTimeout(function () {
				$('#login_email form div.nome').removeClass('invalido');
				$('#login_email form div.email').removeClass('invalido');
				$('#login_email form div.telefone').removeClass('invalido');
			}, 300);
		}
	},
	
	pais: function(id){
		var paises = JSON.parse(Cookie.get('paises', '[]'));
		for(var i=0; i<paises.length; i++){
			if(paises[i].id == id){
				//Cookie.remove('paises');
				this.dados.pais = paises[i];
				this.dados.estado = undefined;
				this.dados.cidade = undefined;
				break;
			}
		}
		
		Radar.app.goToPage('info_cidade_estado');
		Radar.app.carregamentoCompleto();
	},
	
	cidade: function(id){
		var cidades = JSON.parse(Cookie.get('cidades'));
	
		for(var i=0; i < cidades.length; i++){
			if(cidades[i].id == id){
				//Cookie.set('cidade', JSON.stringify(cidades[i]));
				Cookie.remove('cidades');
				this.dados.cidade = cidades[i];
				break;
			}
		}
		
		Radar.app.goToPage('info_cidade_estado');
		
	}
};

var facebook = {
	permissoes: "public_profile,email", //,user_birthday",
	array_permissoes: ["public_profile", "email"], //, "user_birthday"

	login: function () {
		if (window.cordova.platformId == "browser") {
			facebookConnectPlugin.browserInit(701776646536207, "1.0");
		}

		facebookConnectPlugin.login(this.array_permissoes,

			//success
			function (response) {
				usuario.dados.logado = "facebook";
				facebook.importInformacoes();
			},

			//error					
			function (response) {
				usuario.dados.logado = false;

				navigator.notification.alert(
					"Nao foi possivel fazer login atraves do Facebook", // message
					false, // callback
					'Erro', // title
					'OK' // buttonName
				);
			}
		);

	},

	logout: function () {
		facebookConnectPlugin.logout(
			function (success) {
				console.log("Logged out of Facebook");
			},
			function (fail) {
				console.log("Unsuccessful Logout");
			});
	},

	importInformacoes: function () {
		facebookConnectPlugin.api("/me?fields=id,name,email", this.array_permissoes,

			//success
			function (response) {
				usuario.dados.email = response.email;
                if(!usuario.dados.email){ usuario.dados.email = "facebook@radarcidadao.com.br"; }
				usuario.dados.nome = response.name;
				usuario.dados.logado = "facebook";
				usuario.salvar();
				$('#cadastrar h2 .login_type').html(usuario.dados.nome);
				Radar.app.goToPage('cadastrar');
			},

			//error					
			function (response) {
				navigator.notification.alert(
					'Não foi possivel adquirir informações do facebook.', // message
					false, // callback
					'Erro', // title
					'OK');
			}
		);
	}

};